package izayoi.cache;

import java.util.Comparator;

/**
 * Record̃\[^
 * @author es
 */
public abstract class RecordSorter implements Comparator {

    /**
     * ^CvX^vŃ\[g
     * @author es
     */
    public static final class ByTimestamp extends RecordSorter {

        /* ( Javadoc)
         * @see izayoi.cache.RecordSorter#compare(izayoi.cache.Record, izayoi.cache.Record)
         */
        protected int compare(Record arg0, Record arg1) {
            long l0 = arg0.getTimeStamp();
            long l1 = arg1.getTimeStamp();
            if (l0 == l1) {
                return 0;
            } else {
                return l0 > l1 ? 1 : -1;
            }
        }
    }

    /**
     * tB[hvfŃ\[g
     * @author es
     */
    public static final class ByField extends RecordSorter {
        private String key;

        /**
         * \[gtB[hvf
         * @param name
         */
        public ByField(String name) {
            key = name;
        }

        /* ( Javadoc)
         * @see izayoi.cache.RecordSorter#compare(izayoi.cache.Record, izayoi.cache.Record)
         */
        protected int compare(Record arg0, Record arg1) {
            String a0 = arg0.getField(key);
            String a1 = arg1.getField(key);
            return a0.compareTo(a1);
        }
    }

    private boolean isAsc = true;

    /* ( Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    public final int compare(Object arg0, Object arg1) {
        return isAsc ? compare((Record) arg0, (Record) arg1) : compare((Record) arg1, (Record) arg0);
    }

    /**
     * r
     * @param arg0 vfA
     * @param arg1 vfB
     * @return java.util.Comparator#compareƓ
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    abstract protected int compare(Record arg0, Record arg1);

    /**
     * /~̎w
     * @param b ^ŏ/Uō~
     */
    public final void setOrder(boolean b) {
        isAsc = b;
    }

}
