/**
 * NodeController.java
 * Created on 2005/05/16
 * Copyright (c) by es , All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND 
 * CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED 
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A 
 * PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY 
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, 
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF 
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER 
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE 
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS 
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
package izayoi.node;

import izayoi.cache.CacheEntry;
import izayoi.cache.CacheFactory;
import izayoi.cache.Record;

import java.io.IOException;
import java.net.URL;
import java.util.List;

/**
 * alternate of net.sourceforge.shingetsu.node.NodeList
 * @author es
 */
public interface NodeController {

    /**
     * m[hǉ
     * @param nodeUrl Ώۃm[hURL
     */
    public void addNode(URL nodeUrl);

    /**
     * m[h̐mF
     * @param url Ώۃm[hURL
     * @return ĂȂ^
     */
    public boolean checkExist(URL url);

    /**
     * m[h̑ݗL(ǗΏۂƂȂĂ邩?)
     * @param nodeUrl Ώۃm[hURL
     * @return ݂Ȃ^
     */
    public boolean containsNode(URL nodeUrl);

    /**
     * Sm[hؒf
     * @throws IOException
     */
    public void disconnect() throws IOException;

    /**
     * Sm[h擾
     * @return
     */
    public List getAllNodes();

    /**
     * m[h擾
     * @param nodeUrl Ώۃm[hURL
     * @return Ώۃm[h(Ȃnull)
     */
    public Node getNode(URL nodeUrl);

    /**
     * m[h׎擾
     * @return Kȑm[h
     */
    public Node getRandomNode();

    /**
     * m[hURL擾
     * @return URL\L
     */
    public String getSelfURL();

    /**
     * LbVǗNXo^
     * @param cache LbVǗNX
     */
    public void registCacheFactory(CacheFactory cache);

    /**
     * m[h폜
     * @param nodeUrl Ώۃm[hURL
     */
    public void removeNode(URL nodeUrl);

    /**
     * Sm[h/pings
     * @throws IOException
     */
    public void sendPing() throws IOException;

    /**
     * ێĂ鑼m[hɎm[h̍XVʒm
     * @param entry XVꂽLbV
     * @param record XVꂽR[h
     * @throws IOException
     */
    public void sendUpdate(CacheEntry entry, Record record) throws IOException;

    /**
     * ێĂ鑼m[hɍXVʒm
     * @param sender Mm[hURL (nullŎm[h̍XV)
     * @param filename t@C
     * @param time 
     * @param id ʎq
     * @throws IOException
     */
    public void sendUpdate(URL sender, String filename, long time, String id) throws IOException;

    /**
     * @param filename
     * @param time
     * @param id
     * @throws IOException
     */
    public void syncUpdate(String filename, long time, String id) throws IOException;
}